package com.ruoyi.oa.service;

import com.ruoyi.oa.domain.bo.BatchBo;
import com.ruoyi.oa.domain.vo.OaProjectScheduleStepVo;
import com.ruoyi.oa.domain.bo.OaProjectScheduleStepBo;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * 项目进度步骤跟踪Service接口
 *
 * @author hdka
 * @date 2025-05-08
 */
public interface IOaProjectScheduleStepService {

    /**
     * 查询项目进度步骤跟踪
     */
    OaProjectScheduleStepVo queryById(Long trackId);

    /**
     * 查询项目进度步骤跟踪列表
     */
    TableDataInfo<OaProjectScheduleStepVo> queryPageList(OaProjectScheduleStepBo bo, PageQuery pageQuery);

    /**
     * 查询项目进度步骤跟踪列表
     */
    List<OaProjectScheduleStepVo> queryList(OaProjectScheduleStepBo bo);

    /**
     * 新增项目进度步骤跟踪
     */
    Boolean insertByBo(OaProjectScheduleStepBo bo);

    /**
     * 修改项目进度步骤跟踪
     */
    Boolean updateByBo(OaProjectScheduleStepBo bo);

    /**
     * 校验并批量删除项目进度步骤跟踪信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    OaProjectScheduleStepVo maxStepByScheduleId(Long scheduleId);

    void updateByStepAndScheduleId(Long currentStep,Long scheduleId);

    OaProjectScheduleStepVo selectByCurrentStepAndScheduleId(Long currentStep, Long scheduleId);

    /**
     * 更换进度时间线
     * @param boList
     * @return
     */
    int changeBatch(BatchBo boList);

}
